SystemOrganization addCategory: #Ajedrez!
SystemOrganization addCategory: #AJEDREZ!

Object subclass: #Objetos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AJEDREZ'!

Object subclass: #Picture
	instanceVariableNames: 'img width heigth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!Picture class methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/9/2012 22:45'!
picture: imagen 
        ^ self new img: imagen;  yourself ! !

!Picture methodsFor: 'comparing' stamp: 'lizzy28 10/10/2012 01:36'!
= picturen
	"verificamos si dos pictures son iguales"

	| temporary variable names |
	^ self img = picturen img 
	and: [ self heigth  = picturen heigth  and: [self width = picturen width ]] ! !

!Picture methodsFor: 'accessing' stamp: 'jorge 10/13/2012 20:23'!
alLado: imagen

	|temp ado|
	temp:= img copy.
	1 to: temp size do: [:i|
		ado:= img at: i, imagen img at:i.
		temp at: i put: ado 
		].
	^temp ! !

!Picture methodsFor: 'accessing' stamp: 'jorge 10/13/2012 21:07'!
encima: p

	| temp |
	temp := img copy.
	temp := temp, p img.
	^temp
	
! !

!Picture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 15:00'!
espejoH
	"A mi este me parece mas el espejo horizontal"

	| temp  ns s|
	temp := img copy .
	1 to: temp size do: [ :i |
		s:= img at: i.
		ns := ''.
		1 to: s size do: [:c| ns:= (s at: c) asString ,ns asString ].
		temp at: i put: ns.  ].
	^temp  ! !

!Picture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 15:16'!
espejoV
	"espejo vertical"

	| temp|
	temp :=img copy.
	1 to: heigth   do: [ :i |
		temp  at: i put: (img at: heigth -i+1). ].
	^temp  ! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/13/2012 16:48'!
heigth 
	"getter"

	^heigth 	! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/9/2012 22:23'!
heigth: num
	"setter"

	heigth :=  num! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/9/2012 21:50'!
img
     ^img 
! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/9/2012 22:46'!
img: imagen
	img := imagen.
	heigth:= imagen size.
	width:= imagen first size  ! !

!Picture methodsFor: 'initialize-release' stamp: 'lizzy28 10/9/2012 22:19'!
initialize 
      super initialize. 
	width:=0.
	heigth:=0 


	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/5/2012 10:25'!
invColor: c
	"Se va invertir el color (caracter)"
	|n|

	(c= '_') ifTrue:  [n:= '='] .
	(c= '=') ifTrue:  [n:= '_'].
	(c= '.') ifTrue:  [n:= '@'].
	(c= '@') ifTrue:  [n:= '.'].
	 ^ n 

	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 20:57'!
negativo
	"comment stating purpose of message"

	| temp ns neg inv|
	
	temp:= img copy.
	1 to: temp size do: [:i|
		neg := img at: i.
		ns := ''.
		1 to: neg do:[:c| inv invColor: (neg at: c)asString. ns:= inv , ns asString ].
		temp at: i put: ns].
	^temp 
	! !

!Picture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/5/2012 10:41'!
overlay: c1 c2: c2
	"pasamos los parametros"
	 |n|
	 (c1= ' ')ifTrue: [n:= c2]
	            ifFalse: [n:= c1].
	 ^n ! !

!Picture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:24'!
repetirH: n
	"comment stating purpose of message"

	| temp ns repH|
	temp := img copy.
	1 to: temp size do: [:i| 
		ns:= temp at:i.
		1 to: n do:[:j| 
			temp at: i put: ns asString , (temp at:i)].
		].
	^temp! !

!Picture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:34'!
repetirV: n
	"comment stating purpose of message"

	| temp |
	temp = img copy.
	1 to: n do: [:i|
		temp = temp img , temp].
	^temp 
! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/9/2012 22:22'!
width 
	"getter"

	^ width ! !

!Picture methodsFor: 'accessing' stamp: 'lizzy28 10/9/2012 22:22'!
width: num
	"stablish width"

	 width := num! !

Object subclass: #Vistas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AJEDREZ'!

BorderedMorph subclass: #GPicture
	instanceVariableNames: 'pic cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!GPicture class methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 16:19'!
pic: picturen
	"construrctor de GPicture "

	 ^ self new pic: picturen; yourself ! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 10:53'!
cells: numW y:numH 
	"inicializamos la matriz de ajedrez"

	| temporary variable names |
	cells:= Matrix  rows: numH columns: numW ! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/13/2012 16:33'!
cellsTamanio
	"tamao de las celditas"

	^10! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 20:06'!
dibujar: picturen 
	"empezamos a dibujar!!"

	|n|
	n := picturen img size .
	 1 to: n do: [ :i| self parseLine: i   s: (picturen img at: i)]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 16:14'!
initialize 
	"super initialize"

	super initialize ! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 12:01'!
newCellAt: i at: j  color: col
	"crea el colorcito para sibujar"

	| c origin num|
	num:= self cellsTamanio .
	c := Morph new.
	c width: num; height: num .
	origin := self innerBounds origin .
	self addMorph: c.
	c position: ((i -1) * c width) @ ((j -1) * c height) + origin;color: col
	
	
	! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 20:04'!
parseChar: c
	"indicamos el color"

	(c asString  =  '_') ifTrue: [^ (Color lightGray) ].
	(c asString =  '=') ifTrue: [^ (Color gray) ].
	(c asString =  '.') ifTrue: [^ (Color white)  ].
	(c asString =  '@') ifTrue: [^ (Color black) ].
	(c asString =  '#') ifTrue: [^ (Color darkGray) ] ifFalse: [^ (Color blue )]
! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 20:39'!
parseLine: y s: s 
	"parseamos todo la linea"

	|xi xf c colorcito |
	xi:= 1.
	xf:= 2.
	c := s at: xi .
	
	[xf <= s size ] whileTrue: [
		( c=' ' and: (c = (s at: xf) )not )ifTrue: [c:= s at: xf. xi :=xf ].
		((c = ' ')not and: (c = (s at: xf))not) ifTrue: [
											colorcito :=self parseChar: c .
											self newCellAt:xi at: y   color: colorcito .
											c:= s at: xf.
											xi := xf ].
		xf := xf +1.	 ].
	(c = ' ' )not  ifTrue: [ colorcito:=self parseChar: c.
					 	  self newCellAt:xi at: y  color: colorcito .]! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 16:15'!
pic 
	"getter"

	^pic ! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/13/2012 17:09'!
pic: pituren
	"setter picture and resize background an d matrix "

	pic:= pituren.
	self startDraw ! !

!GPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/14/2012 13:03'!
startDraw
	"comenzamos a sealar los tamaos"

	| bWidth bHeight sideSize |
	bWidth := pic width .
	bHeight  := pic heigth  .
	sideSize := self cellsTamanio .
	self  bounds: (5@5 extent: ((bWidth *sideSize)@(bHeight *sideSize )+4)).
	self cells: bHeight  y: bWidth . 
	self dibujar: pic 
	
	
	
	! !

TestCase subclass: #TestGPicture
	instanceVariableNames: 'gPicture1 gPicture2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!TestGPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 21:48'!
setUp 
	"inicializmos"

	|pic1 pic2|
	pic1 := Picture picture: #('#.. ' '##= ' '###@' ' ###').
	pic2 := Picture picture: #(' ###' '###@' '##= ' '#.. ').
	gPicture1 := GPicture pic: pic1 .
	gPicture2 := GPicture  pic: pic2.
	! !

!TestGPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/12/2012 01:37'!
testParseChar
	"probamos el metodo parseChar"

	| color a|
	color := Color lightGray. 
	self assert: (color = (gPicture1 parseChar: '_')).
	color := Color gray.
	self assert: (color = (gPicture1 parseChar: '=')).
	color := Color white . 
	self assert: (color = (gPicture1 parseChar: '.')).
	color := Color black . 
	self assert: (color = (gPicture1 parseChar: '@')).
	color := Color darkGray . 
	self assert: (color = (gPicture1 parseChar: '#')).
	color := Color blue  . 
	self assert: (color = (gPicture1 parseChar: '*'))! !

TestCase subclass: #TestPicture
	instanceVariableNames: 'picture1 picture2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ajedrez'!

!TestPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 15:18'!
setUp 
	"inicializando variables"

	picture1 := Picture new img: #('#.. ' '##= ' '###@' ' ###').
	picture2 := Picture  new ! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:10'!
testAlLado
	"comment stating purpose of message"

	| body |
	picture2 img: #('#.. #.. ' '##= ##= ' '###@###@' ' ### ###').
	body:= picture1 alLado: picture1. 
	self assert: picture2 img = body
	! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:09'!
testEncima
	"comment stating purpose of message"

	| body pn|
	picture2 img: #('#.. ' '##= ' '###@' ' ###' '#@@ ' '##_ ' '###.' ' ###').
	pn := picture1 negativo.
	body := picture1 encima: pn.
	self assert: picture2 = body
	
	! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 15:17'!
testEspejoH
	"prueba espejoH"
	
	|waa|
	picture2 img: #(' ..#' ' =##' '@###' '### ').
	waa := picture1 espejoH .  
	self assert: picture2 img = waa 
	! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/10/2012 15:44'!
testEspejoV
	"prueba espejoV"
	
	|waa|

	picture2 img: #(' ###' '###@' '##= ' '#.. ').
	waa:= picture1 espejoV.
	
	self assert: picture2 img = waa  ! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'lizzy28 10/9/2012 22:56'!
testInit 
	"valores del inicializador"

	self assert: 4 = picture1 width.
	self assert: 4 = picture1 heigth ! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:03'!
testNegativo
	"comment stating purpose of message"

	| body |
	picture2 img: #('#@@ ' '##_ ' '###.' ' ###').
	body:= picture1 negativo.
	self assert: picture2 img = body
	! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:31'!
testRepetirH
	"comment stating purpose of message"

	| body |
	picture2 img: #('#.. #.. #.. ' '##= ##= ##= ' '###@###@###@' ' ### ### ###').
	body := picture1 repetirH: 3.
	self assert: picture2 = body! !

!TestPicture methodsFor: 'as yet unclassified' stamp: 'jorge 10/13/2012 21:38'!
testRepetirV
	"comment stating purpose of message"

	| body |
	picture2 img: #('#.. ' '##= ' '###@' ' ###' '#.. ' '##= ' '###@' ' ###' '#.. ' '##= ' '###@' ' ###').
	body := picture1 repetirV: 3.
	self assert: picture2 = body! !
